import { DatastoreOperations } from './datastore.methods';
import { GetOperation } from '../operations/get.operation';
import { PushOperation, BatchedPushOperation } from '../operations/push.operation';
import { Model } from '../model/model';
import { EditOperation } from '../operations/edit.operation';
import { DeleteOperation, BatchedDeleteOperation } from '../operations/delete.operation';
export interface DatastoreStreamIteratorData {
    key: string;
    value: any;
}
export interface PaginationData {
    skip: number;
    take: number;
}
export declare class Datastore<T extends Model<T>> {
    name: string;
    private store;
    private type;
    methods: DatastoreOperations<T>;
    constructor(name: string, directory: string, type: () => any);
    create(data: T): T;
    push(): PushOperation<T>;
    pushBatched(): BatchedPushOperation<T>;
    get(): GetOperation<T>;
    edit(): EditOperation<T>;
    delete(): DeleteOperation<T>;
    deleteBatched(): BatchedDeleteOperation<T>;
}
