"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
class Human {
    constructor(name, age) {
        this.name = name;
        this.age = age;
    }
}
exports.Human = Human;
class Planet extends _1.Model {
    constructor(name, index) {
        super();
        this.name = name;
        this.index = index;
        this.people = [];
    }
    addHuman() {
        this.people.push(new Human(`Citizen of planet ${this.name} number ${this.people.length + 1}`, 0));
    }
    age() {
        this.people.forEach(human => human.age += 1);
    }
}
exports.Planet = Planet;
exports.testStore = null;
beforeEach(() => __awaiter(this, void 0, void 0, function* () {
    exports.testStore = new _1.Datastore('test', './database', () => Planet);
    const items = yield exports.testStore.get().result();
    yield exports.testStore.deleteBatched().items(items).run();
}));
afterEach(() => __awaiter(this, void 0, void 0, function* () {
    yield exports.testStore.methods.store.close();
}));
exports.testCreateRandomPlanets = (push = false) => __awaiter(this, void 0, void 0, function* () {
    const data = [];
    for (let i = 0; i < 100; i++) {
        data.push(new Planet(`Planet ${i}`, i));
    }
    if (push) {
        yield exports.testStore.pushBatched().items(data).run();
    }
    return data;
});
//# sourceMappingURL=index.test.config.js.map